'use strict';

var plugin = require('tailwindcss/plugin');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var plugin__default = /*#__PURE__*/_interopDefault(plugin);

// src/index.ts
var dataStates = [
  "open",
  "closed",
  "expanded",
  "collapsed",
  "transitioning",
  "opening",
  "closing",
  "snapping",
  "resizing",
  "disabled",
  "active",
  "dragging",
  "selected",
  "today",
  "range-start",
  "range-end",
  "in-range"
];
var src_default = plugin__default.default.withOptions(
  ({ prefix = "corvu" } = {}) => {
    return ({ addVariant }) => {
      for (const state of dataStates) {
        addVariant(`${prefix}-${state}`, [`&[data-${state}]`]);
        addVariant(
          `${prefix}-group-${state}`,
          `:merge(.group)[data-${state}] &`
        );
        addVariant(
          `${prefix}-peer-${state}`,
          `:merge(.peer)[data-${state}] ~ &`
        );
      }
    };
  }
);

module.exports = src_default;
