import plugin from 'tailwindcss/plugin';

// src/index.ts
var dataStates = [
  "open",
  "closed",
  "expanded",
  "collapsed",
  "transitioning",
  "opening",
  "closing",
  "snapping",
  "resizing",
  "disabled",
  "active",
  "dragging",
  "selected",
  "today",
  "range-start",
  "range-end",
  "in-range"
];
var src_default = plugin.withOptions(
  ({ prefix = "corvu" } = {}) => {
    return ({ addVariant }) => {
      for (const state of dataStates) {
        addVariant(`${prefix}-${state}`, [`&[data-${state}]`]);
        addVariant(
          `${prefix}-group-${state}`,
          `:merge(.group)[data-${state}] &`
        );
        addVariant(
          `${prefix}-peer-${state}`,
          `:merge(.peer)[data-${state}] ~ &`
        );
      }
    };
  }
);

export { src_default as default };
