import type { Errors, Extender, FormConfig, Obj, Stores, ValidationFunction, TransformFunction, Helpers, Keyed, ExtenderHandler, Form } from '@felte/common';
type CreateHelpersOptions<Data extends Obj> = {
    config: FormConfig<Data>;
    stores: Stores<Data>;
    validateErrors(data: Data | Keyed<Data>, altValidate?: ValidationFunction<Data> | ValidationFunction<Data>[]): Promise<Errors<Data> | undefined>;
    validateWarnings(data: Data | Keyed<Data>, altWarn?: ValidationFunction<Data> | ValidationFunction<Data>[]): Promise<Errors<Data> | undefined>;
    extender: Extender<Data>[];
    addValidator(validator: ValidationFunction<Data>): void;
    addTransformer(transformer: TransformFunction<Data>): void;
    _getCurrentExtenders(): ExtenderHandler<Data>[];
};
export declare function createHelpers<Data extends Obj>({ stores, config, validateErrors, validateWarnings, _getCurrentExtenders, }: CreateHelpersOptions<Data>): {
    public: Helpers<Data> & Omit<Form<Data>, "form">;
    private: {
        _setFormNode(node: HTMLFormElement): void;
        _getInitialValues: () => Data;
    };
};
export {};
//# sourceMappingURL=helpers.d.ts.map