import type { Obj, Errors, Touched, TransWritable, Traverse, Paths, Keyed, KeyedWritable, Writable, Readable } from '@felte/core';
import type { Accessor } from 'solid-js';
export type FelteAccessor<T> = T extends Obj ? (<R>(selector: (storeValue: T) => R) => R) & (<P extends Paths<T> = Paths<T>, V extends Traverse<T, P> = Traverse<T, P>>(path: P) => V) & (() => T) : T extends boolean | string | null ? (<R>(deriveFn: (storeValue: T) => R) => R) & (() => T) : ((selector: (storeValue: any) => any) => any) & ((path: string) => any) & (() => any);
export type UnknownStores<Data extends Obj> = Omit<Stores<Data>, 'data'> & {
    data: FelteAccessor<Keyed<Data>> & TransWritable<Data>;
};
export type KnownStores<Data extends Obj> = Omit<Stores<Data>, 'data'> & {
    data: FelteAccessor<Keyed<Data>> & KeyedWritable<Data>;
};
export type Stores<Data extends Obj> = {
    data: FelteAccessor<Keyed<Data>> & KeyedWritable<Data>;
    errors: FelteAccessor<Errors<Data>> & Writable<Errors<Data>>;
    warnings: FelteAccessor<Errors<Data>> & Writable<Errors<Data>>;
    touched: FelteAccessor<Touched<Data>> & Writable<Touched<Data>>;
    isSubmitting: FelteAccessor<boolean> & Writable<boolean>;
    isValid: FelteAccessor<boolean> & Readable<boolean>;
    isDirty: FelteAccessor<boolean> & Writable<boolean>;
    isValidating: FelteAccessor<boolean> & Readable<boolean>;
    interacted: FelteAccessor<string | null> & Writable<string | null>;
};
export declare function createAccessor<T, R>(store: Accessor<T>): FelteAccessor<T>;
//# sourceMappingURL=create-accessor.d.ts.map