import { onCleanup } from 'solid-js';
import { createField as createField$1 } from '@felte/core';

function createField(nameOrConfig, config) {
    const { field: coreField, onChange, onInput, onBlur } = createField$1(nameOrConfig, config);
    function field(node) {
        const { destroy } = coreField(node);
        /* istanbul ignore next */
        onCleanup(() => destroy === null || destroy === void 0 ? void 0 : destroy());
        return { destroy };
    }
    return {
        field,
        onChange,
        onInput,
        onBlur,
    };
}

export { createField };
//# sourceMappingURL=create-field.js.map
