import type { FormConfigWithTransformFn, FormConfigWithoutTransformFn, CreateSubmitHandlerConfig, UnknownHelpers, KnownHelpers, Paths } from '@felte/core';
import type { KnownStores, UnknownStores } from './create-accessor';
type Obj = Record<string, any>;
/** The return type for the `createForm` function. */
export type Form<Data extends Obj> = {
    /** Action function to be used with the `use` directive on your `form` elements. */
    form: (node: HTMLFormElement) => {
        destroy: () => void;
    };
    /** Function to handle submit to be passed to the on:submit event. Not necessary if using the `form` action. */
    handleSubmit: (e?: Event) => void;
    /** Function that creates a submit handler. If a function is passed as first argument it overrides the default `onSubmit` function set in the `createForm` config object. */
    createSubmitHandler: (altConfig?: CreateSubmitHandlerConfig<Data>) => (e?: Event) => void;
};
export declare function createForm<Data extends Obj = any, Ext extends Obj = Obj>(config: FormConfigWithTransformFn<Data> & Ext): Form<Data> & UnknownHelpers<Data, Paths<Data>> & UnknownStores<Data>;
export declare function createForm<Data extends Obj = any, Ext extends Obj = Obj>(config?: FormConfigWithoutTransformFn<Data> & Ext): Form<Data> & KnownHelpers<Data, Paths<Data>> & KnownStores<Data>;
export {};
//# sourceMappingURL=create-form.d.ts.map