import type { Obj, ValidationFunction, Extender } from '@felte/common';
import type { AnyZodObject } from 'zod';
type ZodSchema = {
    parseAsync: AnyZodObject['parseAsync'];
};
export type ValidatorConfig = {
    schema: ZodSchema;
    level?: 'error' | 'warning';
};
export declare function validateSchema<Data extends Obj>(schema: ZodSchema): ValidationFunction<Data>;
export declare function validator<Data extends Obj = Obj>({ schema, level, }: ValidatorConfig): Extender<Data>;
export {};
//# sourceMappingURL=index.d.ts.map