import ApexCharts from 'apexcharts/dist/apexcharts.esm.js';
import { ApexOptions } from 'apexcharts';
import { Component } from 'solid-js';

type ChartType = NonNullable<NonNullable<ApexOptions['chart']>['type']>;
type ChartSeries = NonNullable<ApexOptions['series']>;
type FixMeLater = any;
interface ApexChartEvents {
    onAnimationEnd?(chart: ApexCharts, options?: ApexChartProps['options']): void;
    onBeforeMount?(chart: ApexCharts, options?: ApexChartProps['options']): void;
    onMounted?(chart: ApexCharts, options?: ApexChartProps['options']): void;
    onUpdated?(chart: ApexCharts, options?: ApexChartProps['options']): void;
    onMouseMove?(e: MouseEvent, chart?: ApexCharts, options?: ApexChartProps['options']): void;
    onMouseLeave?(e: MouseEvent, chart?: ApexCharts, options?: ApexChartProps['options']): void;
    onClick?(e: MouseEvent, chart?: ApexCharts, options?: ApexChartProps['options']): void;
    onXAxisLabelClick?(e: MouseEvent, chart?: ApexCharts, options?: ApexChartProps['options']): void;
    onLegendClick?(chart: ApexCharts, seriesIndex?: number, options?: ApexChartProps['options']): void;
    onMarkerClick?(e: MouseEvent, chart?: ApexCharts, options?: ApexChartProps['options']): void;
    onSelection?(chart: ApexCharts, options?: ApexChartProps['options']): void;
    onDataPointSelection?(e: MouseEvent, chart?: ApexCharts, options?: ApexChartProps['options']): void;
    onDataPointMouseEnter?(e: MouseEvent, chart?: ApexCharts, options?: ApexChartProps['options']): void;
    onDataPointMouseLeave?(e: MouseEvent, chart?: ApexCharts, options?: ApexChartProps['options']): void;
    onBeforeZoom?(chart: ApexCharts, options?: ApexChartProps['options']): void;
    onBeforeResetZoom?(chart: ApexCharts, options?: ApexChartProps['options']): void;
    onZoomed?(chart: ApexCharts, options?: ApexChartProps['options']): void;
    onScrolled?(chart: ApexCharts, options?: ApexChartProps['options']): void;
    onBrushScrolled?(chart: ApexCharts, options?: ApexChartProps['options']): void;
}
type ApexChartProps = {
    type: ChartType;
    options: ApexOptions;
    series: ChartSeries;
    width?: string | number;
    height?: string | number;
    [key: string]: FixMeLater;
} & ApexChartEvents;
declare const SolidApexCharts: Component<ApexChartProps>;

export { type ApexChartProps, SolidApexCharts };
